#!/bin/sh

pkg=$1
ver=$2
arch=$3
dist=$4

# NOTE: rebuildd has already stripped the epoch from $ver

buildlog="${pkg}_${ver}_${arch}.build"

remove_buildlog() {
    if [ -h "$buildlog" ]; then
	rm -f "$(readlink "$buildlog")"
    fi
    rm -f "$buildlog"
}

# the architecture that builds architecture independent packages
all_arch=amd64

# the architecture that appears in the .changes filename
changes_arch=$arch

mkdir -p "$dist"
cd "$dist" || exit 1

set -- --no-source --no-run-lintian --verbose --apt-update --apt-upgrade \
       --no-apt-distupgrade --arch="$arch"

{{ rebuildd_build_code_to_set_cmdline }}

jobfile="${pkg}_${ver}_${arch}.job"
if [ ! -e "$jobfile" ]; then
    echo "ERROR: job file $jobfile not found"
    exit 1
fi

dsc=$(cat "$jobfile")
if [ ! -e "$dsc" ]; then
    echo "ERROR: source package $dsc not found"
    exit 1
fi

build_any() {
    local host_arch=$1
    local a=
    shift

    while [ $# -gt 0 ]; do
        a=$1 && shift
        if [ "$a" = all ]; then
            continue
        fi
        if dpkg-architecture --host-arch "$host_arch" --is "$a"; then
            return 0
        fi
    done

    return 1
}

binnmu=$(expr "$ver" : '.*+b\([0-9]\+\)')
if [ -n "$binnmu" ]; then
    set -- "$@" --no-arch-all --make-binNMU="Rebuild in $dist requested." \
	--binNMU="$binnmu" --maintainer="{{ rebuildd_binnmu_maintainer }}"
elif [ "$arch" = "$all_arch" ]; then
    set -- "$@" --arch-all
    # sometimes there's no architecture specific package to build
    dsc_arches=$(sed -n -e 's/^Architecture: //p' "$dsc")
    if ! build_any "$arch" $dsc_arches; then
        set -- "$@" --no-arch-any
        changes_arch=all
    fi
else
    set -- "$@" --no-arch-all
fi

# experimental repos use aptitude resolver to fetch deps in non-automatic repos
case "$dist" in
    *-experimental)
	set -- "$@" --build-dep-resolver=aptitude
    ;;
esac

export DEB_BUILD_OPTIONS="parallel={{ rebuildd_parallel }}"

try=1
while true; do
    echo "$0: STARTING BUILD OF $dsc (arch=$arch dist=$dist version=$ver try=$try)"
    echo "$0: SBUILD OPTS:" "$@"

    sbuild "$@" "$dsc"
    code=$?

    if [ $code -ne 0 ] && [ -e "$buildlog" ] && grep -q "E: apt-get update failed" "$buildlog"; then
	try=$(( try + 1 ))
	if [ $try -le 3 ]; then
	    # Drop the failed buildlog to avoid clutter
	    remove_buildlog

	    echo "$0: sleeping 60s due to probable mirror inconsistency"
	    sleep 60

	    echo "$0: retrying build"
	    continue
	fi
    fi
    break
done
remove_buildlog

if [ $code -eq 0 ]; then
    echo "$0: SUCCESSFUL BUILD OF $dsc (arch=$arch dist=$dist version=$ver)"
else
    echo "$0: FAILED BUILD OF $dsc (arch=$arch dist=$dist version=$ver) with exit code $code"
    changes="${pkg}_${ver}_${changes_arch}.changes"
    if [ -e "$changes" ]; then
	dcmd rm -f "$changes"
    fi
    if [ -e "$dsc" ]; then
	dcmd rm -f "$dsc"
    fi
    rm -f "$jobfile"
fi

exit $code
